import { BaseType } from "../Base/Base";
declare type Pair<T, K> = {
    key: T;
    value: K;
};
export declare type MapType<T, K> = {
    front: () => Pair<T, K> | undefined;
    back: () => Pair<T, K> | undefined;
    forEach: (callback: (element: Pair<T, K>, index: number) => void) => void;
    getElementByPos: (pos: number) => Pair<T, K>;
    getElementByKey: (key: T) => Pair<T, K> | undefined;
    setElement: (key: T, value: K) => void;
    eraseElementByPos: (pos: number) => void;
    eraseElementByKey: (key: T) => void;
    union: (other: MapType<T, K>) => void;
    getHeight: () => number;
} & BaseType;
declare const _default: new <T, K>(arr?: Pair<T, K>[] | undefined, cmp?: ((x: T, y: T) => number) | undefined) => MapType<T, K>;
export default _default;
